From 5803536ced962be465bd5ee0b2de664bf705311a Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 18 2018 15:48:00 +0000
Subject: [PATCH 1/48] Undo ordered dict code in prep for libmodulemd wrapper


Revert "Preserve modulemd field ordering in dumps/dumps_all"

This reverts commit 362ffeb159728d72000f9eb2b29a9c6844097374.

Revert "Add internal method to dump into an OrderedDict"

This reverts commit 1a7b656e87b168dda74ceecc88ef81ca8ecb55f7.

---

diff --git a/modulemd/__init__.py b/modulemd/__init__.py
index 1d2c31e..86d43f1 100644
--- a/modulemd/__init__.py
+++ b/modulemd/__init__.py
@@ -40,7 +40,6 @@ Example usage:
     mmd.dump("out.yaml")
 """
 
-from collections import OrderedDict
 import sys
 import datetime
 import dateutil.parser
@@ -61,22 +60,6 @@ from modulemd.profile import ModuleProfile
 
 supported_mdversions = ( 1, )
 
-# From https://stackoverflow.com/a/16782282
-# Enable yaml handling of OrderedDict, rather than serialize
-# dict values alphabetically
-def _represent_ordereddict(dumper, data):
-    value = []
-
-    for item_key, item_value in data.items():
-        node_key = dumper.represent_data(item_key)
-        node_value = dumper.represent_data(item_value)
-
-        value.append((node_key, node_value))
-
-    return yaml.nodes.MappingNode(u'tag:yaml.org,2002:map', value)
-yaml.representer.SafeRepresenter.add_representer(OrderedDict,
-                                                 _represent_ordereddict)
-
 def load_all(f):
     """Loads a metadata file containing multiple modulemd documents
     into a list of ModuleMetadata instances.
@@ -115,8 +98,7 @@ def dumps_all(l):
 
     :param list l: List of ModuleMetadata instances
     """
-    return yaml.safe_dump_all([x._dumpd_ordered() for x in l],
-                              explicit_start=True)
+    return yaml.safe_dump_all([x.dumpd() for x in l], explicit_start=True)
 
 class ModuleMetadata(object):
     """Class representing the whole module."""
@@ -359,17 +341,17 @@ class ModuleMetadata(object):
         with open(f, "w") as outfile:
             outfile.write(data)
 
-    def _dumpd_ordered(self):
-        """Dumps the metadata into a OrderedDict.
+    def dumpd(self):
+        """Dumps the metadata into a dictionary.
 
-        :rtype: collections.OrderedDict
+        :rtype: dict
         """
-        doc = OrderedDict()
+        doc = dict()
         # header
         doc["document"] = "modulemd"
         doc["version"] = self.mdversion
         # data
-        d = OrderedDict()
+        d = dict()
         if self.name:
             d["name"] = self.name
         if self.stream:
@@ -384,18 +366,18 @@ class ModuleMetadata(object):
         d["description"] = self.description
         if self.eol:
             d["eol"] = str(self.eol)
-        d["license"] = OrderedDict()
+        d["license"] = dict()
         d["license"]["module"] = sorted(list(self.module_licenses))
         if self.content_licenses:
             d["license"]["content"] = sorted(list(self.content_licenses))
         if self.buildrequires or self.requires:
-            d["dependencies"] = OrderedDict()
+            d["dependencies"] = dict()
             if self.buildrequires:
                 d["dependencies"]["buildrequires"] = self.buildrequires
             if self.requires:
                 d["dependencies"]["requires"] = self.requires
         if self.community or self.documentation or self.tracker:
-            d["references"] = OrderedDict()
+            d["references"] = dict()
             if self.community:
                 d["references"]["community"] = self.community
             if self.documentation:
@@ -405,39 +387,39 @@ class ModuleMetadata(object):
         if self.xmd:
             d["xmd"] = self.xmd
         if self.profiles:
-            d["profiles"] = OrderedDict()
+            d["profiles"] = dict()
             for profile in self.profiles.keys():
                 if self.profiles[profile].description:
                     if profile not in d["profiles"]:
-                        d["profiles"][profile] = OrderedDict()
+                        d["profiles"][profile] = dict()
                     d["profiles"][profile]["description"] = \
                         str(self.profiles[profile].description)
                 if self.profiles[profile].rpms:
                     if profile not in d["profiles"]:
-                        d["profiles"][profile] = OrderedDict()
+                        d["profiles"][profile] = dict()
                     d["profiles"][profile]["rpms"] = \
                         sorted(list(self.profiles[profile].rpms))
         if self.api:
-            d["api"] = OrderedDict()
+            d["api"] = dict()
             if self.api.rpms:
                 d["api"]["rpms"] = sorted(list(self.api.rpms))
         if self.filter:
-            d["filter"] = OrderedDict()
+            d["filter"] = dict()
             if self.filter.rpms:
                 d["filter"]["rpms"] = sorted(list(self.filter.rpms))
         if self.buildopts:
-            d["buildopts"] = OrderedDict()
+            d["buildopts"] = dict()
             if self.buildopts.rpms:
-                d["buildopts"]["rpms"] = OrderedDict()
+                d["buildopts"]["rpms"] = dict()
                 if self.buildopts.rpms.macros:
                     d["buildopts"]["rpms"]["macros"] = \
                             self.buildopts.rpms.macros
         if self.components:
-            d["components"] = OrderedDict()
+            d["components"] = dict()
             if self.components.rpms:
-                d["components"]["rpms"] = OrderedDict()
+                d["components"]["rpms"] = dict()
                 for p in self.components.rpms.values():
-                    extra = OrderedDict()
+                    extra = dict()
                     extra["rationale"] = p.rationale
                     if p.buildorder:
                         extra["buildorder"] = p.buildorder
@@ -453,9 +435,9 @@ class ModuleMetadata(object):
                         extra["multilib"] = sorted(list(p.multilib))
                     d["components"]["rpms"][p.name] = extra
             if self.components.modules:
-                d["components"]["modules"] = OrderedDict()
+                d["components"]["modules"] = dict()
                 for p in self.components.modules.values():
-                    extra = OrderedDict()
+                    extra = dict()
                     extra["rationale"] = p.rationale
                     if p.buildorder:
                         extra["buildorder"] = p.buildorder
@@ -465,40 +447,18 @@ class ModuleMetadata(object):
                         extra["ref"] = p.ref
                     d["components"]["modules"][p.name] = extra
         if self.artifacts:
-            d["artifacts"] = OrderedDict()
+            d["artifacts"] = dict()
             if self.artifacts.rpms:
                 d["artifacts"]["rpms"] = sorted(list(self.artifacts.rpms))
         doc["data"] = d
         return doc
 
-    def dumpd(self):
-        """Dumps the metadata into a dictionary.
-
-        :rtype: dict
-        """
-        def _convert_ordered(orig, new):
-            """Recurse over a nested OrderedDict, converting each to
-            a dict()
-            """
-            for key, val in orig.items():
-                if not isinstance(val, OrderedDict):
-                    new[key] = val
-                    continue
-
-                new[key] = dict()
-                _convert_ordered(val, new[key])
-
-        ordered = self._dumpd_ordered()
-        converted = dict()
-        _convert_ordered(ordered, converted)
-        return converted
-
     def dumps(self):
         """Dumps the metadata into a string.
 
         :rtype: str
         """
-        return yaml.safe_dump(self._dumpd_ordered(), default_flow_style=False)
+        return yaml.safe_dump(self.dumpd(), default_flow_style=False)
 
     @property
     def mdversion(self):

